// Initialisierungen ================================================

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

uint8_t		direction,temp,temp2,step[4],juststep;
uint16_t	stepcnt,istpos,sollpos,ocw,mod_stepcnt,max_stepcnt;
volatile   uint8_t done;

SIGNAL (SIG_OUTPUT_COMPARE1A) {
  done = 1;
}

void init (void) {
  DDRA 		= 0b11111111;		// Einsen definieren Ausgnge
  PORTA 	= 0b00000000;		// eine 0 ausgeben
  
  DDRB 		= 0;				// Port B komplett Eingnge
  PORTB 	= 0b00001111;		// Pull-Up-Widerstnde fr Taster aktivieren
								// Wenn Richtungsbit "0", dann schaltet eine "1" im
								// Port den Pullup an
  
  step[0] 	= 0b10100000;		// Definition der Schritt-"Bits", PORT A !!!
  step[1] 	= 0b10010000;
  step[2] 	= 0b01010000;
  step[3] 	= 0b01100000;
  
  TCCR1B 	= 0b00001101;		// CTC on OCR1A, CK/1024  , Seite 108
  TIMSK 	= 0b00010000;		// Output compare match interrupt OCR1A
  
  done = 1;
  istpos = 515;					// Motor steht nach dem Einschalten bei "0000"
  sollpos = 0;
  stepcnt = 0;
  juststep = 0;
  direction = 1;
 

  //outp((1<<ACIS1)+(1<<ACIE)+(1<<ACD)+(1<<ACO),ACSR);  // Analog Comparator einstellen
  
  sei();						// Set global interrupts
}





// Module fr die Rampe =============================================
	
void mod1(uint8_t direction,uint8_t juststep) {	

	  done = 0;
	  mod_stepcnt = 10;
	
	  while (mod_stepcnt != 0) {  
	  
  	    if (done == 1) {
	  
	  	    ocw 	= 180;
		    OCR1A 	= ocw;
				
		    done = 0;
	        mod_stepcnt=mod_stepcnt - 1;
		  
	        if (direction == 1) {
			
			  juststep = juststep + 1;
			  if (juststep>3) { juststep = 0; }
			  PORTA = step[juststep];
			
			} else {
	        
			  juststep = juststep - 1;
		      if (juststep>3) { juststep = 3; }
		      PORTA = step[juststep];
	        }  
	    }		// End of "if(done == 1)"
	  }	// End of "while(stepcnt != 0)"
}	  
		
void mod2(uint8_t direction,uint8_t juststep) {	

	  done = 0;
	  mod_stepcnt = 10;
	
	  while (mod_stepcnt != 0) {  
	  
  	    if (done == 1) {
	  
	  	    ocw 	= 170;
		    OCR1A 	= ocw;
				
		    done = 0;
	        mod_stepcnt=mod_stepcnt - 1;
		  
	        if (direction == 1) {
			
			  juststep = juststep + 1;
			  if (juststep>3) { juststep = 0; }
			  PORTA = step[juststep];
			
			} else {
	        
			  juststep = juststep - 1;
		      if (juststep>3) { juststep = 3; }
		      PORTA = step[juststep];
	        }  
	    }		// End of "if(done == 1)"
	  }	// End of "while(stepcnt != 0)"
}		  
		
void mod3(uint8_t direction,uint8_t juststep) {	

	  done = 0;
	  mod_stepcnt = 10;
	
	  while (mod_stepcnt != 0) {  
	  
  	    if (done == 1) {
	  
	  	    ocw 	= 130;
		    OCR1A 	= ocw;
				
		    done = 0;
	        mod_stepcnt=mod_stepcnt - 1;
		  
	        if (direction == 1) {
			
			  juststep = juststep + 1;
			  if (juststep>3) { juststep = 0; }
			  PORTA = step[juststep];
			
			} else {
	        
			  juststep = juststep - 1;
		      if (juststep>3) { juststep = 3; }
		      PORTA = step[juststep];
	        }  
	    }		// End of "if(done == 1)"
	  }	// End of "while(stepcnt != 0)"
}	
		  
		
void mod4(uint8_t direction,uint8_t juststep,uint16_t stepcnt) {
	  
	
	  while (stepcnt != 0) {  
	  
  	    if (done == 1) {
	  
	  	    ocw 	= 100;
		    OCR1A 	= ocw;
				
		    done = 0;
	        stepcnt=stepcnt - 1;
		  
	        if (direction == 1) {
			
			  juststep = juststep + 1;
			  if (juststep>3) { juststep = 0; }
			  PORTA = step[juststep];
			
			} else {
	        
			  juststep = juststep - 1;
		      if (juststep>3) { juststep = 3; }
		      PORTA = step[juststep];
			  
	        }
	    }		// End of "if(done == 1)"
	  }	// End of "while(stepcnt != 0)"
}








void mod_led(uint8_t juststep) {
 
 if (temp == 0b00001110) {
	PORTA = 0b00000001;
 }
 
 if (temp == 0b00001101) {
 	PORTA = 0b00000010;
 }

 if (temp == 0b00001011) {
	PORTA = 0b00000100;
 }
 
 if (temp == 0b00000111) {
    PORTA = 0b00001000;
 }
 
}



// Hauptprogramm mit der Endlosschleife =============================

int main (void) {

 init();
  
 for (;;) {
    
	temp = PINB & 0b00001111;
	
  if (temp == 0b00001110)	{ 	// Taster 1
  
    sollpos = 515;
  
  }
	
  if (temp == 0b00001101)	{	// Taster 2
  
    sollpos = 700;
  
  }
	
  if (temp == 0b00001011)	{ 	// Taster 3

    sollpos = 780;

  }
		
  if (temp == 0b00000111) 	{ 	// Taster 4
	
    sollpos = 1500;
  
  }

	
  if (istpos>sollpos) {			// Motorbewegung ja/nein
 
    stepcnt = istpos-sollpos;
    direction = 0;			// Richtung "down"
  
  } else {
    
    stepcnt = sollpos-istpos;
    direction = 1;			// Richtung "up"
  
  }

	

 

// Distanzprfungen und Geschwindigkeitsregelungen ==================

   if (stepcnt >  120) {		// Groe Distanzen ==================

    if (istpos != sollpos) {   

      done = 0;
	  
	  mod1(direction,juststep);
	  mod2(direction,juststep);
	  mod3(direction,juststep);
	  
	  stepcnt = stepcnt-120;
	  
	  mod4(direction,juststep,stepcnt);
	  
	  mod3(direction,juststep);
	  mod2(direction,juststep);
	  mod1(direction,juststep);
	  
	  istpos = sollpos;

    }		// End of "if(istpos != sollpos)"
	
	mod_led(juststep);
	
  }		// End of "if(stepcnt > 120)"

	
   if (stepcnt <= 120) { 		// Kleine Distanzen =================
   if (stepcnt > 80)   {		// Distanzen 120 - 80 ===============

    if (istpos != sollpos) {   

      done = 0;
	  
	  mod1(direction,juststep);
	  mod2(direction,juststep);
	
	  stepcnt = stepcnt-80;
	  
	  mod4(direction,juststep,stepcnt);
	
	  mod2(direction,juststep);
	  mod1(direction,juststep);
	  
	  istpos = sollpos;

    }    // End of "if(istpos != sollpos)"
		
	mod_led(juststep);
	
   }    // End of "if(stepcnt > 80)"	
   
   if (stepcnt <= 80 && stepcnt > 40)  { // Distanzen 80 - 40 ======
   
       if (istpos != sollpos) {   

      done = 0;
	  
	  mod1(direction,juststep);
	
	  stepcnt = stepcnt-40;
	  
	  mod4(direction,juststep,stepcnt);
	
	  mod1(direction,juststep);
	  
	  istpos = sollpos;

    }    // End of "if(istpos != sollpos)"
	
	mod_led(juststep);
   
   }    // End of "if(stepcnt > 40)"	
   
   if (stepcnt <= 40)  {       // Distanzen 40 - 0 =================
   
       if (istpos != sollpos) {   

      done = 0;
		  
	  mod4(direction,juststep,stepcnt);
	 
	  istpos = sollpos;

    }    // End of "if(istpos != sollpos)"
	
	mod_led(juststep);
   
   }    // End of "if(stepcnt <= 40)"	
  }    // End of "if(stepcnt > 120)"
 }    //End of "for (;;)" 
 
 return (0);    // weil "int" raus, hier Wert (eine 0) ausgeben

}  // End of "int main (void)"